#!/bin/sh

clear

printf "[Raspberry Pi Synchronet BBS Installer v0.1]\n\n"

printf "[Installing make]\n"
apt-get -y install make > /dev/null 2>&1
printf "[Installing g++]\n"
apt-get -y install g++ > /dev/null 2>&1
printf "[Installing C Library]\n"
apt-get -y install linux-libc-dev > /dev/null 2>&1
printf "[Installing NCurses Library]\n"
apt-get -y install libncurses5-dev > /dev/null 2>&1
printf "[Installing Netscape Portable Runtime Library]\n"
apt-get -y install libnspr4-dev > /dev/null 2>&1
printf "[Installing Perl]\n"
apt-get -y install perl > /dev/null 2>&1
printf "[Installing Python]\n"
apt-get -y install python > /dev/null 2>&1
printf "[Installing CVS]\n"
apt-get -y install cvs > /dev/null 2>&1
printf "[Installing Capabilities Library]\n"
apt-get -y install libcap2-dev > /dev/null 2>&1
printf "[Installing GNU Debugger]\n"
apt-get -y install gdb > /dev/null 2>&1
printf "[Installing Info-ZIP Zip]\n"
apt-get -y install zip > /dev/null 2>&1
printf "[Installing Info-ZIP Unzip]\n"
apt-get -y install unzip > /dev/null 2>&1
printf "[Installing Lrzsz]\n"
apt-get -y install lrzsz > /dev/null 2>&1
printf "[Installing G-Kermit]\n"
apt-get -y install gkermit > /dev/null 2>&1

printf "[Creating root SBBS folder]\n"
cd /
mkdir /sbbs
cd /sbbs

printf "[Getting latest SBBS source code]\n"
wget 'http://cvs.synchro.net/cgi-bin/viewcvs.cgi/*checkout*/install/GNUmakefile'

printf "[Compiling SBBS (Go grab a coffee!)]\n"
make install SYMLINK=1 RELEASE=1 USE_DOSEMU=1

printf "[Getting and installing latest init scripts]\n"
cd /etc/init.d
wget http://cvs.synchro.net/cgi-bin/viewcvs.cgi/*checkout*/install/init.d/sbbs.debian
mv sbbs.debian sbbs
chmod +x sbbs

printf "[Installing SBBS Service]\n"
insserv -v sbbs

printf "[Getting latest Terminfo file]\n"
cd /sbbs
wget http://cvs.synchro.net/cgi-bin/viewcvs.cgi/*checkout*/install/terminfo

printf "[Compiling Terminfo file]\n"
tic terminfo

printf "[Creating sbbs user and group]\n"
groupadd sbbs
useradd -g sbbs sbbs

printf "[Setting ownership on SBBS directories and files]\n"
chown -R sbbs:sbbs /sbbs

printf "[Setting up SBBS specific logging]\n"
echo "local3.*                 /var/log/sbbs.log" >> /etc/syslog.conf
touch /var/log/sbbs.log

printf "[Setting up SBBS log rotation]\n"
echo "/var/log/sbbs*.log {\\
      weekly\\
      missingok\\
      rotate 52\\
      notifempty\\
      create 640 root adm\\
      sharedscripts\\
      postrotate\\
              invoke-rc.d rsyslog reload > /dev/null\\
      endscript\\
}" > /etc/logrotate.d/sbbs

printf "[Restarting logging service]\n"
service rsyslog restart

printf "[All done!]\n"
